ParseNode subclass: #CascadeNode
	instanceVariableNames: 'receiver messages '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
!CascadeNode commentStamp: '<historical>' prior: 0!
The first message has the common receiver, the rest have receiver == nil, which signifies cascading.!


!CascadeNode methodsFor: 'initialize-release'!
receiver: receivingObject messages: msgs
	" Transcript show: 'abc'; cr; show: 'def' "

	receiver _ receivingObject.
	messages _ msgs! !


!CascadeNode methodsFor: 'code generation'!
emitForValue: stack on: aStream

	receiver emitForValue: stack on: aStream.
	1 to: messages size - 1 do: 
		[:i | 
		aStream nextPut: Dup.
		stack push: 1.
		(messages at: i) emitForValue: stack on: aStream.
		aStream nextPut: Pop.
		stack pop: 1].
	messages last emitForValue: stack on: aStream! !

!CascadeNode methodsFor: 'code generation'!
sizeForValue: encoder

	| size |
	size _ (receiver sizeForValue: encoder) + (messages size - 1 * 2).
	messages do: [:aMessage | size _ size + (aMessage sizeForValue: encoder)].
	^size! !


!CascadeNode methodsFor: 'printing'!
printOn: aStream indent: level
	self printOn: aStream indent: level precedence: 0! !

!CascadeNode methodsFor: 'printing'!
printOn: aStream indent: level precedence: p
	| thisPrec |
	p > 0 ifTrue: [aStream nextPut: $(].
	thisPrec _ messages first precedence.
	receiver printOn: aStream indent: level precedence: thisPrec.
	1 to: messages size do: 
		[:i | 
		(messages at: i) printOn: aStream indent: level.
		i < messages size
			ifTrue: [aStream nextPut: $;.
					thisPrec >= 2 ifTrue: [aStream crtab: level]]].
	p > 0 ifTrue: [aStream nextPut: $)]! !


!CascadeNode methodsFor: 'C translation' stamp: 'jm 11/15/2003 04:52'!
asTranslatorNode

	^ TStmtListNode new
		setArguments: #()
		statements:
			(messages collect: [:msg |
				msg asTranslatorNode receiver: receiver asTranslatorNode])
! !


!CascadeNode methodsFor: 'elements' stamp: 'jens 1/21/2009 22:01'!
asSyntaxElement

	| me |
	me _ messages last asSyntaxElement
		receiver: receiver asSyntaxElement.
	messages allButLast do: [:msg |
		me addToCascade: msg asSyntaxElement ].

	^me
! !
