ImageFrameMorph subclass: #ScratchTalkBubbleMorph
	instanceVariableNames: 'leftPointerForm rightPointerForm pointLeft contentsMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-UI-Support'!

!ScratchTalkBubbleMorph methodsFor: 'intialization' stamp: 'ee 3/2/2009 11:53'!
bePrompt: aBoolean

	self initFromForm: (ScratchFrameMorph skinAt: #promptBubbleFrame).
	aBoolean
		ifTrue: [leftPointerForm _ (ScratchFrameMorph skinAt: #promptBubblePointer)]
		ifFalse: [leftPointerForm _ (ScratchFrameMorph skinAt: #talkBubbleTalkPointer)].
	rightPointerForm _ leftPointerForm flipBy: #horizontal centerAt: leftPointerForm center.
	self changed.
! !

!ScratchTalkBubbleMorph methodsFor: 'intialization' stamp: 'jm 3/21/2008 14:03'!
beThoughtBubble: aBoolean
	"If true, then be a thought bubble. Otherwise, be a talk bubble."

	aBoolean
		ifTrue: [leftPointerForm _ (ScratchFrameMorph skinAt: #talkBubbleThinkPointer)]
		ifFalse: [leftPointerForm _ (ScratchFrameMorph skinAt: #talkBubbleTalkPointer)].
	rightPointerForm _ leftPointerForm flipBy: #horizontal centerAt: leftPointerForm center.
! !

!ScratchTalkBubbleMorph methodsFor: 'intialization' stamp: 'jm 8/11/2008 17:56'!
initialize
	"Initialize the forms for all my elements."

	super initialize.
	self initFromForm: (ScratchFrameMorph skinAt: #talkBubbleFrame).
	self beThoughtBubble: false.
	pointLeft _ false.

	contentsMorph _ MultilineStringMorph new
		centerText: true;
		font: (ScratchFrameMorph getFont: #TalkBubble).
	contentsMorph
		borderWidth: 0;
		lock.
	self addMorph: contentsMorph.
! !


!ScratchTalkBubbleMorph methodsFor: 'accessing' stamp: 'jm 7/9/2008 07:59'!
message

	contentsMorph ifNil: [^ ''].
	^ contentsMorph contents
! !

!ScratchTalkBubbleMorph methodsFor: 'accessing' stamp: 'jens 11/6/2009 12:08'!
message: aString
	"(ScratchTalkBubbleMorph new message: 'Hello!!') openInWorld"

	| maxWidth xOffset |
	
	(aString isKindOf: String)
		ifTrue: [
			maxWidth _ 145.
			contentsMorph
				width: maxWidth;
				contents: aString asUTF8 withBlanksTrimmed;
				fitContents ]
		ifFalse: [
			maxWidth _ 145.
			contentsMorph _ aString.
			self addMorphFront: contentsMorph ].


	self extent: contentsMorph extent + (0@28).
	xOffset _ contentsMorph width >= maxWidth
		ifTrue: [3]
		ifFalse: [((self width - contentsMorph width) // 2) + 3].
	contentsMorph position: self position + (xOffset @ 5).
! !

!ScratchTalkBubbleMorph methodsFor: 'accessing' stamp: 'jm 2/11/2009 10:29'!
noPointer
	"Use no pointer at all."

	leftPointerForm _ rightPointerForm _ Form extent: 0@leftPointerForm height depth: 1.
! !

!ScratchTalkBubbleMorph methodsFor: 'accessing' stamp: 'jm 12/1/2006 10:47'!
pointLeft: aBoolean

	pointLeft _ aBoolean.
	self changed.
! !


!ScratchTalkBubbleMorph methodsFor: 'drawing' stamp: 'jm 12/19/2006 23:45'!
drawOn: aCanvas

	| f x y |
	super drawOn: aCanvas.
	y _ self bottom - leftPointerForm height.
	pointLeft
		ifTrue: [f _ leftPointerForm. x _ self left + 7]
		ifFalse: [f _ rightPointerForm. x _ self right - 53].
	aCanvas paintImage: f at: (x@y) truncated.
! !

!ScratchTalkBubbleMorph methodsFor: 'drawing' stamp: 'jm 12/1/2006 12:14'!
hasTranslucentColor

	^ false
! !


!ScratchTalkBubbleMorph methodsFor: 'geometry' stamp: 'jm 11/29/2006 16:40'!
extent: aPoint

	super extent: (aPoint max: 65@52).
! !

!ScratchTalkBubbleMorph methodsFor: 'geometry' stamp: 'jm 7/9/2008 07:53'!
insetBottom

	^ self bottom - leftPointerForm height + 3
! !
