package enchanting;

// HSV stores colors (hue, saturation, luminosity)
public class HSV {
	public float hue, sat, val;
	public HSV(float h, float s, float v) {
		this.hue = h;
		this.sat = s;
		this.val = v;
	}
	public HSV() { this.hue = this.sat = this.val = -1.0f; }
	public boolean isValid() { return this.sat != -1; }
	
	public int colorID() {
		// quantifies the shade into a number for easy comparison
		// with lots of magic numbers!
		
		// 1 = invalid, 2 = black, 3 = grey, 4 = white
		if (!isValid()) return 1;
		if (val < 25) return 2;	// black
		if (sat < 25) {
			if (val > 45) return 4;  // white
			return 3; // gray
		}
		
		// it is a colour
		// give us a number representing one of 6 hues
		// 5 = red, 6 = yellow, 7 = green, 8 = cyan, 9 = blue, 10 = magenta
		
		float c = hue / 60.0f;
		// center the result on the colour
		c += 0.5f;
		if (c >= 6.0f) c -= 6.0f;
		
		return (int)(c) + 5;
	}
}